## reduce-src-2014-11-30.tar.bz2

=== Makefile ===
# This is a hand-written top-level Makefile


.PHONY: dist all csl psl

VERBOSE =
# When debugging it may be useful to invole scripts/make.sh in a noisy way...
#VERBOSE = -v

all:
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

dist:
	$(SHELL) $(VERBOSE) scripts/dist.sh

# This script tries a fairly basic sanity check to see if the
# support-tools, include files and libraries needed to build the
# CSL version of Reduce are available. It is NOT a perfect test but
# may be useful in case of difficulty. See README.testprogram in the
# csl directory for further explanation and especially for how to
# run this test step by step manually.

csltest:
	$(SHELL) $(VERBOSE) scripts/csl-sanity-check.sh

# I have csl and psl as special targets here because those names are
# also names of top-level directories, but eg "make csl" wants to
# delegate to the build directory and does not relate to the top-level
# csl directory being up to date.

csl:
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

psl:
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

install:
	@echo No install: target yet!

%::
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

# end of Makefile

=== debianbuild/Makefile ===

SNAPSHOT=$(shell LANG=C date "+%Y%m%d")
NOW=$(shell LANG=C date "+%a, %d %b %Y %T %z")
CHANGELOG=reduce/debian/changelog
BUILDTOPDIR=C

all:	update-changelog reduce-packages

update-changelog:
	if head -1 $(CHANGELOG) | grep $(SNAPSHOT) >/dev/null ; then : ; \
        else  \
	  ( echo "reduce ("$(SNAPSHOT)") unstable; urgency=low" ; \
            echo ; \
            echo "  * New Snapshot." ; echo ; \
	    echo " -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net> " $(NOW) ;\
	    echo ) > $(CHANGELOG).tmp ; \
          cat $(CHANGELOG) >> $(CHANGELOG).tmp ; \
          mv $(CHANGELOG).tmp $(CHANGELOG); \
        fi
 

$(BUILDTOPDIR).stamp:
	rm -rf $(BUILDTOPDIR)
	( time svn export -r HEAD .. $(BUILDTOPDIR) ) | tee $(BUILDTOPDIR).log
	touch $(BUILDTOPDIR).stamp

reduce-packages:	$(BUILDTOPDIR).stamp debpackages rpmpackages

debpackages:
	cd reduce ; debuild --set-envvar BUILDTOPDIR=$(realpath $(BUILDTOPDIR)) -b -us -uc

rpmpackages:
	fakeroot alien -k -r reduce-*_$(SNAPSHOT)_*.deb


source-archive:
	-rm -rf reduce-source-$(SNAPSHOT) *.tar.bz2
	svn export .. reduce-source-$(SNAPSHOT)
	$(MAKE) reduce-source-core-$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-csl-$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-csl-embedded-$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-csl-support-$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-psl-$(SNAPSHOT).tar.bz2
	ls -lh *.tar.bz2
#	-rm -rf reduce-source-$(SNAPSHOT)

reduce-source-core-$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-core-$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		--exclude=reduce-source-$(SNAPSHOT)/csl \
		--exclude=reduce-source-$(SNAPSHOT)/psl \
		reduce-source-$(SNAPSHOT)

reduce-source-csl-$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-csl-$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		--exclude=reduce-source-$(SNAPSHOT)/csl/support-packages \
		--exclude=reduce-source-$(SNAPSHOT)/csl/embedded \
		--exclude=reduce-source-$(SNAPSHOT)/csl/new-embedded \
		--exclude=reduce-source-$(SNAPSHOT)/csl/generated-c \
		reduce-source-$(SNAPSHOT)/csl

reduce-source-csl-embedded-$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-csl-embedded-$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		reduce-source-$(SNAPSHOT)/csl/embedded \
		reduce-source-$(SNAPSHOT)/csl/new-embedded \
		reduce-source-$(SNAPSHOT)/csl/generated-c

reduce-source-csl-support-$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-csl-support-$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		reduce-source-$(SNAPSHOT)/csl/support-packages

reduce-source-psl-$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-psl-$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		reduce-source-$(SNAPSHOT)/psl


# end of Makefile

=== jlisp/Makefile ===
# Makefile for "Jlisp"
# Now using a reasonably standard "make" syntax.


all:	reduce.jar minireduce.jar jlisp.jar

.PHONY:	clean
clean:
	-rm -rf *.jar *.class *.img *.log *.bak *~ uk inline*

# The idea here is that the jar file contains EVERYTHING needed for
# Reduce, and so "java -jar reduce.jar" will launch the system with its
# default image file.

reduce.jar:	core/*.java reduce_manifest reduce.img
	javac -d . core/*.java
	cp reduce.img default.img
	-rm -f reduce.jar
	jar cmf reduce_manifest reduce.jar uk default.img
	rm default.img

# minireduce.jar is a cut-down system not containing all the Reduce modules.
# It will thus be smaller (albeit less capable of performing advanced
# operations).

minireduce.jar:	core/*.java reduce_manifest minireduce.img
	javac -d . core/*.java
	cp minireduce.img default.img
	-rm -f minireduce.jar
	jar cmf reduce_manifest minireduce.jar uk default.img
	rm default.img

# jlisp.jar is merely the Lisp system without any algebra. If may sometimes
# be easier to work with this smaller system while developing or interfacing?

jlisp.jar:	core/*.java jlisp_manifest jlisp.img
	javac -d . core/*.java
	cp jlisp.img default.img
	-rm -f jlisp.jar
	jar cmf jlisp_manifest jlisp.jar uk default.img
	rm default.img


JLISP   = java -jar jlisp.jar
MEM=300M
STK=8M
# FLAGS=-g would switch on a debugging mode that makes all backtraces noisy.
#   Eg "make testall FLAGS=-g"
REDUCE	= java -Xmx$(MEM) -Xms$(MEM) -Xss$(STK) -jar reduce.jar $(FLAGS)


###########################################################################

# Part of redlog does load-time calculation based on the path passed
# here that probably requires it to be an absolute path...

ifeq ($(findstring Windows, "$(OS)"), Windows)
C = $(shell cygpath -m "$(abspath ../csl/cslbase)")
else
C = $(abspath ../csl/cslbase)
endif

# I make the targets here .PHONY so that (eg) "make reduce.img" always
# rebuilds the image even though I have not got careful dependencies set up
# to make it clear why this is necessary.

.PHONY:	jlisp.img
jlisp.img:
	javac -d . core/*.java
	-rm -f jlisp.img
	java uk.co.codemist.jlisp.core.Jlisp -w -v -z -o jlisp.img \
	"$(C)/buildcsl.lsp" -D@cslbase="$(C)" -- jlispimg.log



.PHONY:	reduce.img
reduce.img:
	javac -d . core/*.java
	-rm -f reduce.img
	java uk.co.codemist.jlisp.core.Reduce -w -v -z -o reduce.img \
	"$(C)/buildreduce.lsp" -D@srcdir="$(C)" -D@reduce="$(C)/../.." \
	-- reduce.log


.PHONY:	minireduce.img
minireduce.img:
	javac -d . core/*.java
	-rm -f minireduce.img
	java uk.co.codemist.jlisp.core.Reduce -w -v -z -o minireduce.img \
	"$(C)/buildreduce.lsp" -Dminireduce -D@srcdir="$(C)" \
	-D@reduce="$(C)/../.." -- reduce.log


.PHONY:	testall
testall:
	mkdir -p testlogs
	$(REDUCE) -w "$(C)/testall.red" -D@srcdir="$(C)" \
		-D@reduce="$(C)/../.." -- testlogs/testreduce.log
	$(REDUCE) -w "$(C)/checkall.red" -D@srcdir="$(C)" \
		-D@reduce="$(C)/../.." -- testlogs/checkall.log

.PHONY:	test1
# Use:    make test1 which=modulename
test1:
	mkdir -p testlogs
	$(REDUCE) -w -v "$(C)/testall.red" -D@srcdir="$(C)" \
		-D@reduce="$(C)/../.." -Dwhich=$(which) -- testlogs/test$(which).log

.PHONY:	debug1
# Use:    make debug1 which=modulename
#         as test1 but passes the "-g" flag that makes all backtraces noisy.
debug1:
	mkdir -p testlogs
	$(REDUCE) -w -v -g "$(C)/testall.red" -D@srcdir="$(C)" \
		-D@reduce="$(C)/../.." -Dwhich=$(which) -- testlogs/test$(which).log

.PHONY:	checkall
checkall:
	mkdir -p testlogs
	$(REDUCE) -w "$(C)/checkall.red" -D@srcdir="$(C)" \
		-D@reduce="$(C)/../.." -- testlogs/checkall.log

# end of Makefile

=== vsl/Makefile ===
# Makefile for vsl

ifeq ($(findstring Windows, $(OS)), Windows)
CC = i686-w64-mingw32-gcc
CXX = i686-w64-mingw32-g++
else
CC = gcc
CXX = g++
endif

all:	vsl vsl.img vslmanual.pdf

vsl:	vsl.c
	$(CC) -O2 -Wall vsl.c -lm -o vsl

vsl.img:	vsl library.lsp
	./vsl -z library.lsp

reduce:
	mkdir -p modules
	rm -f modules/* reduce.img
	./vsl -z -ireduce.img -D@srcdir=. -D@reduce=.. \
	  buildreduce.lsp | tee reduce.log
# I will protect the image from writing so I feel safe!
	chmod -w reduce.img

# To run Reduce go
#    ./vsl -ireduce.img
# then
#    in "alg.tst";
# runs a test/demo script.

clean:
	rm -f *.o *.bak *.exe *.log *.img vsl

# To build this you need to go "make vslmanual.pdf" explicitly. It is
# not done automatically because not everybody will have installed
# pdflatex.

vslmanual.pdf:	vslmanual.tex vslfunctions.tex
	touch vslmanual.ind
	pdflatex vslmanual.tex
	makeindex vslmanual.idx
	pdflatex vslmanual.tex
	pdflatex vslmanual.tex

# end of Makefile

=== winbuild/Makefile ===
# Makefile for getting ready to make Windows installer package

# If the following path to Inno Setup is correct then running "make" will
# be able to run Inno Setup automatically. If it is not then there will
# be no terrible harm, but when you run "make" it will end by displaying
# a message asking you to run Inno Setup manually.

inno=/cygdrive/c/Program Files (x86)/Inno Setup 5

all:	package-win

# The sub-parts of this build process are controlled by a collection
# of datestamp files *.stamp. "make clean" will remove all of these and so
# force you to remake everything from scratch. Otherwise once one of these
# has been created it just sits there and prevents re-building of its
# component

# "C" is a copy of the main Reduce source tree. It will include
# everything that is checked in to the subversion repository but it will
# not include locally created files. If you have updated a file locally
# (even if you have not yet committed your changes) then that update will
# find its way into the clean tree. The purpose of all this is so that the
# setup process can dump large sections of the Reduce tree into the
# installation set without needing to enumerate files individually. A previous
# version of the script used the local copy of the main tree and could end
# up getting ready to distribute large amounts of temporary or experimental
# material.

C.stamp:
	rm -rf C
	( time svn export .. C ) > C.log
	touch C.stamp

# The CSL version of Reduce gets build using an elaborate scheme that
# creates a sort of Windows "fat binary" such that a single binary can be
# used on 32 or 64-bit systems and to run as a Windowed version or under
# a Windows console - or under cygwin mintty or using an X server!

csl.stamp:	C.stamp
	script -c "time ./cslbuild.sh" csl.log
	touch csl.stamp

# The PSL version gets built for both 32 and 64-bit architectures. Because
# it is built in the clean tree it will be a fully fresh pair of versions
# fully re-build here.

psl.stamp:	C.stamp
	(cd C ; \
		./configure --with-psl ; \
		./configure --with-psl -with-m32 ; \
		script -c "time make psl" ../psl.log )
	touch psl.stamp

# Documentation is also re-generated in the clean tree so that regardless
# of history it should end up fresh and tidy.

docs.stamp:	C.stamp
	(cd C/doc/misc ; script -c "time make"  ../../../docmisc.log )
	(cd C/doc/manual ; script -c "time make" ../../../docmanual.log )
	touch docs.stamp
	
# reduce.iss is the script for Inno Setup. It is created here by
# setting the string @here@ in it to the absolute path to this
# directory. That is so that when Inno Setup processes it there is no
# reliance on any "current directory".

reduce.iss:	reduce.iss.in
	sed -e 's#\@here\@#$(subst /,\\,$(shell cygpath -m $(abspath .)))#; s#\@VERSION\@#$(shell date +%Y-%m-%d)#' \
		<reduce.iss.in >reduce.iss

# The final step in the creation of an installer involved saving PSL
# images for both 32 and 64-bit versions and then invoking Inno Setup
# to pack up everything.

package-win:	C.stamp csl.stamp psl.stamp docs.stamp reduce.iss
	C/psl/saveimage.sh C/pslbuild/x86_64-pc-windows \
		$(abspath .) '$$reduce/lib/psl' && mv reduce.img reduce64.img
	C/psl/saveimage.sh C/pslbuild/i686-pc-windows \
		$(abspath .) '$$reduce/lib/psl'
	if test -x "$(inno)/ISCC.exe"; then "$(inno)/ISCC" reduce.iss;\
		else echo Please run Innosetup on winbuild/reduce.iss; fi

# It will be a really good idea to go "make clean" before any wholesale
# "make" here - this removes all the working files that get created
# during the build. It will leave any final installer that is in the
# directory "Output"

clean:
	rm -rf cyg*.exe add*.exe *red*.exe *.img C \
		cslwin32 cslwin64 cslcyg32 cslcyg64 \
		cslbuild log reduce.iss dll*.c *.stamp

# end of Makefile

=== csl/cslbase/Makefile ===
# Do local maintenance in the cslbase directory

csl.pdf:	csl.tex
	rm -f csl.ind
	pdflatex csl
	makeindex csl
	pdflatex csl

lispfile:
	./lispfile.sh



.PHONY: coverage.c
coverage.c:
	gcc glyphtable.c -o glyphtable
	./glyphtable wxfonts/*.glyphs

doxtract:	doxtract.c
	gcc doxtract.c -o doxtract

csl.tex:	doxtract *.h *.c *.cpp *.red *.lsp
	./doxtract -p csl -o csl.tex *.h *.c *.cpp *.red *.lsp

# end of Makefile in cslbase

=== csl/new-embedded/Makefile ===
# Makefile for embedded and other custom versions of Reduce

# The Makefile here expect to use GNU make, but all the scripts
# obeyed are in fact VERY simple and so anybody who wants to build some
# alternative way ought not to have much trouble.


# The idea here is that there may be many different embedded variants.
# All of them will require a Reduce image file (typically called "reduce.img")
# but I show here how to build two variants. The first if a full image
# including ALL of the capabilites of Reduce. The second (minireduce) is
# cut down, and while not quite minimal is at least a lot smller. Anybody
# trying minireduce will want to review the file "packages.map" where it is
# built to ensure that they include just what THEY want. The version I provide
# here is merely a starting position.

# You should go either "make reduce" or "make minireduce" first to create
# the version of "reduce.img" that interests you.

.PHONY:	reduce
reduce:
	cd reduce-image && make reduce.img && cp reduce.img ..

.PHONY:	minireduce
minireduce:
	cd minireduce-image && make reduce.img && cp reduce.img ..

# So far I provide only one sample. I call it "proc" and it illustrates
# a procedural interface into Reduce.

.PHONY:	proc
proc:
	cd procedural && make

# Obviuously one needs to tody up occasionally.

clean:
	-rm -f reduce.img
	cd reduce-image && make clean
	cd minireduce-image && make clean
	cd procedural && make clean

# end of Makefile

=== csl/winbuild/Makefile ===
#
# multi-target packed executable for Reduce
#

.PHONY:	all all32 all64 clean fullclean

all:
	case `uname` in \
	*WOW64*) $(MAKE) all64; ;; \
	*) $(MAKE) all32; ;; \
	esac

# The clean target does not
clean:
	rm -rf *.exe *.img reduce.fonts *.log

fullclean:	clean
	rm -rf cyg32 cyg64 win32 win64

all32:	reduce32.exe winreduce32.exe reduce.img reduce.fonts
	ls -lhd *reduce*.exe reduce.img reduce.fonts
	echo all 32-bit versions built

all64:	reduce32.exe reduce.exe winreduce32.exe winreduce.exe reduce.img reduce.fonts
	ls -lhd *reduce*.exe reduce.img reduce.fonts
	echo all 64 and 32-bit versions built

# Note that it is vital that when resources are added here that they are
# added in the order shown.

WIN32=win32/csl/reduce.com
WIN64=win64/csl/reduce.com
CYG32=cyg32/csl/reduce.exe
CYG64=cyg64/csl/reduce.exe
WWIN32=win32/csl/reduce.exe
WWIN64=win64/csl/reduce.exe

# Reduce for 32-bit machines, suitable for Windowed or console use
# I may end up believeing that there is no point in having this one
# in that just reduce64.exe may serve well for everybody
#
reduce32.exe:	addresources.exe stub.c cygwin32-isatty.exe $(WIN32) $(CYG32)
	i686-w64-mingw32-gcc -DFAT32 -O2 stub.c --static -lz -o reduce32.exe
	i686-w64-mingw32-strip reduce32.exe
	./addresources reduce32.exe cygwin32-isatty.exe $(WIN32) $(CYG32)

# Reduce for 32 or 64-bit machines, Windowed or console use. ie
# as general as I can make it!
#
reduce.exe:	addresources.exe stub.c cygwin32-isatty.exe \
		cygwin64-isatty.exe $(WIN32) $(WIN64) $(CYG32) $(CYG64)
	i686-w64-mingw32-gcc -DFAT64 -O2 stub.c --static -lz -o reduce.exe
	i686-w64-mingw32-strip reduce.exe
	./addresources reduce.exe cygwin32-isatty.exe cygwin64-isatty.exe \
		$(WIN32) $(WIN64) $(CYG32) $(CYG64)

# Reduce for 32 or 64 bit machines for launching by double-clicking.
# This differs from reduce.exe in that it will not create a console if
# double-clicked, and will detach from the console if you try launching
# it from there. It does not support cygwin or X11.
#
winreduce.exe:	addresources.exe stub.c $(WWIN32) $(WWIN64)
	i686-w64-mingw32-gcc -DFATWIN -O2 stub.c \
		-Wl,--subsystem,windows --static -lz -o winreduce.exe
	i686-w64-mingw32-strip winreduce.exe
	./addresources winreduce.exe $(WWIN32) $(WWIN64)

winreduce32.exe:	$(WWIN32)
	cp $(WWIN32) winreduce32.exe

reduce.img:	win32/csl/reduce.img
	case `uname` in \
	 *WOW64*) cp win64/csl/reduce.img .; ;; \
	 *) cp win32/csl/reduce.img .; ;; \
	esac

reduce.fonts:	win32/csl/reduce.fonts
	cp -r win32/csl/reduce.fonts .

addresources.exe:	addresources.c
	gcc addresources.c -lz -oaddresources.exe

cygwin32-isatty.exe:	cygwin-isatty.c
	gcc -O2 cygwin-isatty.c -o cygwin32-isatty.exe
	strip cygwin32-isatty.exe

cygwin64-isatty.exe:	cygwin-isatty.c
	x86_64-pc-cygwin-gcc -O2 cygwin-isatty.c -o cygwin64-isatty.exe
	x86_64-pc-cygwin-strip cygwin64-isatty.exe

# End of Makefile

=== generic/libreduce/Makefile ===
# $Id: Makefile 1603 2012-03-26 07:43:00Z thomas-sturm $
#
# This Makefile is a temporary solution.
#
# libreduce.a is a library for using REDUCE from C programs
# communicating via sockets. It is restricted to unix-like systems.
#
# Say "make", and you will find "libreduce.a" in the subdirectory
# corresponding to your architecture. In a subdir "examples" there you
# will find an executable "lrtest". There is currently no written
# documentation yet. Instead, have a look at "src/lrtest.c" and
# "src/reduce.h".
#
# 03/2009 - T. Sturm (sturm@redlog.eu)

BUILD = $(shell ../../scripts/findhost.sh $(shell src/config.guess))

all:	
	cd src; \
	autoconf; \
	autoheader
	mkdir -p $(BUILD); \
	cd $(BUILD); \
	../src/configure --disable-universal; \
	make

clean:
	cd $(BUILD) && make clean

distclean: all
	cd $(BUILD) && make distclean
	/bin/rm -rf $(BUILD)

=== generic/redfront/Makefile ===
# $Id: Makefile 2608 2014-07-30 13:08:56Z thomas-sturm $
#
# This Makefile is a temporary solution.
#
# As a quick start just go "make install" and find rfcsl and rfpsl in
# trunk/bin.
#
# Usage Details:
#
# make =                 make redfront. The binary will be located in the
#                        redfront subdirectory of the directory corresponding
#                        to your architecture
#
# make install-csl:      create a suitable symbolic link rfcsl in trunk/bin
#
# make install-psl:      create a suitable symbolic link rfpsl in trunk/bin
#
# make install =         make install-csl install-psl
#
# make uninstall:        remove symbolic links rfcsl and rfpsl from trunk/bin
#
# make maintainer-clean: reset this directory to its original state. This
#                        includes uninstalling and deleting all files generated
#                        by make all.
#
# Reports bugs and problems to the Reduce Help Forum at SourceForge:
# http://sourceforge.net/forum/forum.php?forum_id=899364
# T. Sturm (sturm@redlog.eu)

BUILD = $(shell ../../scripts/findhost.sh $(shell src/config.guess))

#LIBEDIT_TGZ = libedit-20130712-3.1.tar.gz
LIBEDIT_TGZ = libedit-20140620-3.1.tar.gz
LIBEDIT = $(shell basename $(LIBEDIT_TGZ) .tar.gz)
BUILD_LIBEDIT = $(BUILD)/libedit

.PHONY: all csl psl install install-csl install-psl uninstall uninstall-csl \
	uninstall-psl clean distclean maintainer-clean echo

all: $(BUILD)/redfront/redfront

debug: $(BUILD)/redfront-debug/redfront

src/configure:
	cd src; \
	autoconf; \
	autoheader

$(BUILD)/redfront/redfront: $(BUILD)/libedit/include/editline/readline.h src/configure
	mkdir -p $(BUILD)/redfront; \
	cd $(BUILD)/redfront; \
	../../src/configure --with-libedit=$(abspath $(BUILD)/libedit); \
	make

$(BUILD)/redfront-debug/redfront: $(BUILD)/libedit/include/editline/readline.h src/configure
	mkdir -p $(BUILD)/redfront-debug; \
	cd $(BUILD)/redfront-debug; \
	../../src/configure --with-libedit=$(abspath $(BUILD)/libedit) --enable-debug; \
	make

$(LIBEDIT):
	tar xvf ../../libedit/$(LIBEDIT_TGZ)
#ln -sf $(LIBEDIT) libedit

$(BUILD)/libedit/include/editline/readline.h: $(LIBEDIT)
	mkdir -p $(BUILD_LIBEDIT)
	cd $(BUILD_LIBEDIT); \
	../../$(LIBEDIT)/configure --prefix=$$(pwd) --disable-dependency-tracking; \
	make install

install-home-bin: install-home-bin-csl install-home-bin-psl

install-home-bin-csl:
	@if test ! -e ~/bin/rfcsl -a ! -h ~/bin/rfcsl; then \
	   echo "Copying to ~/bin/rfcsl"; \
	   cp $(BUILD)/redfront/redfront ~/bin/rfcsl; \
	else \
	   echo "File ~/bin/rfcsl already exists"; \
	fi

install-home-bin-psl:
	@if test ! -e ~/bin/rfpsl -a ! -h ~/bin/rfpsl; then \
	   echo "Copying to ~/bin/rfpsl"; \
	   cp $(BUILD)/redfront/redfront ~/bin/rfpsl; \
	else \
	   echo "File ~/bin/rfpsl already exists"; \
	fi

install: install-csl install-psl

install-csl: $(BUILD)/redfront/redfront
	@cd ../../bin && \
	if test ! -e rfcsl -a ! -h rfcsl; then \
	   echo "Creating symbolic link ../../bin/rfcsl"; \
	   ln -s ../generic/redfront/$(BUILD)/redfront/redfront rfcsl; \
	else \
	   echo "File ../../bin/rfcsl already exists"; \
	fi

install-psl: $(BUILD)/redfront/redfront
	@cd ../../bin && \
	if test ! -e rfpsl -a ! -h rfpsl ; then \
	   echo "Creating symbolic link ../../bin/rfpsl"; \
	   ln -s ../generic/redfront/$(BUILD)/redfront/redfront rfpsl; \
	else \
	   echo "File ../../bin/rfpsl already exists"; \
	fi

uninstall: uninstall-csl uninstall-psl

uninstall-csl:
	@cd ../../bin && \
	if test ! -h rfcsl; then \
	   echo "No symbolic link ../../bin/rfcsl found"; \
	else \
	   echo "Deleting symbolic link ../../bin/rfcsl"; \
	   rm -f rfcsl; \
	fi

uninstall-psl:
	@cd ../../bin && \
	if test ! -h rfpsl; then \
	   echo "No symbolic link ../../bin/rfpsl found"; \
	else \
	   echo "Deleting symbolic link ../../bin/rfpsl"; \
	   rm -f rfpsl; \
	fi

clean:
	cd $(BUILD)/libedit && make clean
	cd $(BUILD)/redfront && make clean

distclean: uninstall
	/bin/rm -rf $(BUILD) csl psl libedit*
	cd ../../bin && rm -f rfcsl rfpsl

maintainer-clean: distclean
	cd src && make -f Makefile.in maintainer-clean

echo:
	@echo $(BUILD)

=== generic/rlsmt/Makefile ===
rlsmt.img: mkrlsmt.red
	redpsl < mkrlsmt.red

=== csl/new-embedded/minireduce-image/Makefile ===
# Makefile for building reduce.img suitable for embedded use. This
# will always want to run on the current machine!


COMMON=-O2 -I. -DPAGE_BITS=19 -DHAVE_CONFIG_H=1 -DEMBEDDED=1

# The idea here is that I want a C compiler and set of flags that will
# generate a 32-bit executable. Rather than use a separate configuration
# step I will use GNU Make trickery to detect a collection of cases
# I expect to be enough to get me going rather often. I will assume I am
# going to use (a version of) gcc...
# If this does not work or you do not like it merely set CC and CFLAGS
# manually for yourself.

ifeq ($(findstring Windows, $(OS)), Windows)

CC1:=$(shell i686-w64-mingw32-gcc -v 2>&1)
CC2:=$(shell gcc-3 -v 2>&1)
CC3:=$(shell gcc hello.c -o hello && ./hello 2>&1)

ifneq ($(CC1),)
CC=i686-w64-mingw32-gcc
CFLAGS=$(COMMON)
else
ifneq ($(CC2),)
CC=gcc-3
CFLAGS=-mno-cygwin $(COMMON)
else
ifeq ($(findstring [[4]], $(CC3)), [[4]])
CC=gcc
CFLAGS=$(COMMON)
else
CC=echo "Unable to build 32 bit application" && exit 1 &&
CFLAGS=
endif
endif
endif

else

CC3:=$(shell gcc hello.c -o hello && ./hello 2>&1)
CC4:=$(shell gcc -m32 hello.c -o hello && ./hello 2>&1)

ifeq ($(findstring [[4]], $(CC3)), [[4]])
CC=gcc
CFLAGS=$(COMMON)
else
ifeq ($(findstring [[4]], $(CC4)), [[4]])
CC=gcc
CFLAGS=-m32 $(COMMON)
else
CC=echo "Unable to build 32 bit application" && exit 1 &&
CFLAGS=
endif
endif

endif

S=../../cslbase
R=../../..

VPATH=$(S)

all:	reduce reduce.img image.c

reduce:		arith01.o arith02.o arith03.o arith04.o arith05.o \
		arith06.o arith07.o arith08.o arith09.o arith10.o \
		arith11.o arith12.o bytes.o char.o \
		csl.o cslmpi.o cslread.o eval1.o eval2.o eval3.o \
		eval4.o fasl.o fns1.o fns2.o fns3.o fwin.o gc.o \
		preserve.o print.o restart.o sysfwin.o termed.o \
		stubs.o
	$(CC) $(CFLAGS) arith01.o arith02.o arith03.o arith04.o arith05.o \
		arith06.o arith07.o arith08.o arith09.o arith10.o \
		arith11.o arith12.o bytes.o char.o \
		csl.o cslmpi.o cslread.o eval1.o eval2.o eval3.o \
		eval4.o fasl.o fns1.o fns2.o fns3.o fwin.o gc.o \
		preserve.o print.o restart.o sysfwin.o termed.o \
		stubs.o -lm -o reduce

.c.o:                                                                          <
	$(CC) $(CFLAGS) -c -o $@ $<

# Create the reduce.img file

reduce.img:	reduce
	-rm -f reduce.img
	./reduce -z -Dminireduce -Dno_init_file $(S)/buildreduce.lsp \
		-D@srcdir=$(S) -D@reduce=$(R) -o reduce.img -- image.log

make-image:	../make-image.c
	$(CC) $(CFLAGS) ../make-image.c -o make-image

image.c:	make-image reduce.img
	./make-image
	cp image.c ../minireduce-image.c

clean:
	-rm -f *.o reduce hello reduce.img image.log make-image image.c

HEADERS = config.h \
	$(S)/arith.h $(S)/bytes.h $(S)/clsyms.h $(S)/cslerror.h \
	$(S)/cslread.h $(S)/entries.h $(S)/externs.h $(S)/fwin.h \
	$(S)/headers.h $(S)/machine.h $(S)/proc.h $(S)/sockhdr.h \
	$(S)/stream.h $(S)/syscsl.h $(S)/tags.h $(S)/termed.h \
	$(S)/version.h


arith01.o:	$(S)/arith01.c $(HEADERS)
arith02.o:	$(S)/arith02.c $(HEADERS)
arith03.o:	$(S)/arith03.c $(HEADERS)
arith04.o:	$(S)/arith04.c $(HEADERS)
arith05.o:	$(S)/arith05.c $(HEADERS)
arith06.o:	$(S)/arith06.c $(HEADERS)
arith07.o:	$(S)/arith07.c $(HEADERS)
arith08.o:	$(S)/arith08.c $(HEADERS)
arith09.o:	$(S)/arith09.c $(HEADERS)
arith10.o:	$(S)/arith10.c $(HEADERS)
arith11.o:	$(S)/arith11.c $(HEADERS)
arith12.o:	$(S)/arith12.c $(HEADERS)
bytes.o:	$(S)/bytes.c $(HEADERS)
bytes1.o:	$(S)/bytes1.c $(S)/opnames.c $(HEADERS)
char.o:		$(S)/char.c $(HEADERS)
csl.o:		$(S)/csl.c $(HEADERS)
cslmpi.o:	$(S)/cslmpi.c $(S)/mpipack.c $(HEADERS)
cslread.o:	$(S)/cslread.c $(HEADERS)
driver.o:	$(S)/driver.c $(HEADERS)
embedcsl.o:	$(S)/embedcsl.c $(S)/csl.c $(HEADERS)
eval1.o:	$(S)/eval1.c $(HEADERS)
eval2.o:	$(S)/eval2.c $(HEADERS)
eval3.o:	$(S)/eval3.c $(HEADERS)
eval4.o:	$(S)/eval4.c $(HEADERS)
fasl.o:		$(S)/fasl.c $(HEADERS)
fns1.o:		$(S)/fns1.c $(HEADERS)
fns2.o:		$(S)/fns2.c $(HEADERS)
fns3.o:		$(S)/fns3.c $(HEADERS)
fwin.o:		$(S)/fwin.c $(HEADERS)
gc.o:		$(S)/gc.c $(HEADERS)
preserve.o:	$(S)/preserve.c $(HEADERS)
print.o:	$(S)/print.c $(HEADERS)
restart.o:	$(S)/restart.c machineid.c $(HEADERS)
sysfwin.o:	$(S)/sysfwin.c $(HEADERS)
termed.o:	$(S)/termed.c $(HEADERS)

# end of Makefile

=== debianbuild/reduce/debian/changelog ===
reduce (20120521) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Mon, 21 May 2012 20:57:39 +0100

=== debianbuild/reduce/debian/control ===
Source: reduce
Section: math
Priority: optional
Maintainer: REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>
Build-Depends: autoconf, libedit-dev, libx11-dev, libxext-dev, libxft-dev, texlive-latex-base, texlive-fonts-extra, tex4ht, debhelper (>= 7.0.50~)
Standards-Version: 3.9.1
Homepage: http://reduce-algebra.sf.net/

Package: reduce-common
Architecture: all
Depends: gnuplot-x11, ${misc:Depends}
Description: REDUCE Computer Algebra System -- common files
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the files that are independent of the Lisp system used.

Package: reduce-csl
Architecture: any
Depends: reduce-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: REDUCE Computer Algebra System -- CSL version
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the files for the CSL (Codemist Standard Lisp)
 version of REDUCE.


Package: reduce-psl
Architecture: i386 amd64 kfreebsd-amd64 kfreebsd-i386 mips powerpc sparc alpha hppa
Depends: reduce-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: REDUCE Computer Algebra System -- PSL version
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the files for the PSL (Portable Standard Lisp)
 version of REDUCE.

Package: reduce-addons
Architecture: any
Depends: reduce-csl (= ${source:Version}) | reduce-psl (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Useful addons for the REDUCE Computer Algebra System
 These include:
   reduce-mode, an emacs mode
   redfront, a frontend with line editing and color output
   breduce, a REDUCE batch processing utility

=== debianbuild/reduce/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

ifdef BUILDTOPDIR
TOPDIR=$(BUILDTOPDIR)
else
TOPDIR=../..
endif

SYSTEMNAME=$(shell $(TOPDIR)/config.guess)

OSVER=$(shell $(TOPDIR)/scripts/findos.sh)
PSLVER=$(shell $(TOPDIR)/scripts/pslver.sh)
KNOWNPSLVER=AMD64 AMD64_ext amd64 linux

BUILDPSL=$(filter $(PSLVER),$(KNOWNPSLVER))

BUILDDIR=$(shell $(TOPDIR)/scripts/findhost.sh $(SYSTEMNAME))

CSLBUILDDIR=$(TOPDIR)/cslbuild/$(BUILDDIR)
PSLBUILDDIR=$(TOPDIR)/pslbuild/$(BUILDDIR)

DOCSRCDIR=$(TOPDIR)/doc/manual
DOCMISCDIR=$(TOPDIR)/doc/misc

DOCBASENAME=manual
EXTRADOCIMAGEBASENAMES=bild cmsy10 gnuplotex turtleeg

GENERICTOPDIR=$(TOPDIR)/generic

REDFRONTSRCDIR=$(GENERICTOPDIR)/redfront/src
REDFRONTBUILDDIR=$(GENERICTOPDIR)/redfront/$(BUILDDIR)/redfront

INSTALLDIR:=debian/tmp
SHAREDIR=$(INSTALLDIR)/usr/share/reduce
REDFRONTSHAREDIR=$(INSTALLDIR)/usr/share/reduce-addons/redfront
LIBDIR=$(INSTALLDIR)/usr/lib/reduce
TTFONTDIR=$(INSTALLDIR)/usr/share/fonts/truetype/reduce
TYPE1FONTDIR=$(INSTALLDIR)/usr/share/fonts/X11/Type1
FONTDIR=$(INSTALLDIR)/usr/share/reduce/fonts
DOCDIR=$(INSTALLDIR)/usr/share/doc/reduce
ADDONDOCDIR=$(INSTALLDIR)/usr/share/doc/reduce-addons
BINDIR=$(INSTALLDIR)/usr/bin
MANDIR=$(INSTALLDIR)/usr/share/man
EMACSSITELISPDIR=$(INSTALLDIR)/usr/share/emacs/site-lisp/reduce
EMACSSITESTARTDIR=$(INSTALLDIR)/etc/emacs/site-start.d

RSYNC_CMD=rsync -a --cvs-exclude --delete --delete-excluded


%:
	dh $@ 

distclean:
	dh_distclean
	-make -C $(DOCMISCDIR) clean
	-make -C $(DOCSRCDIR) clean
	-test -d $(CSLBUILDDIR) && make -C $(CSLBUILDDIR) distclean
ifneq ($(BUILDPSL),)
	-test -d $(PSLBUILDDIR) && make -C $(PSLBUILDDIR) distclean
endif
	rm -rf $(GENERICTOPDIR)/redfront/$(BUILDDIR)
	rm -f $(REDFRONTSRCDIR)/Makefile $(REDFRONTSRCDIR)/config.h   

clean: 
	dh_clean
#	cd $(TOPDIR) ; make clean
	-make -C $(DOCMISCDIR) clean
	-make -C $(DOCSRCDIR) clean
	-test -d $(CSLBUILDDIR) && make -C $(CSLBUILDDIR) clean 
ifneq ($(BUILDPSL),)   
	-test -d $(PSLBUILDDIR) && make -C $(PSLBUILDDIR) clean
endif
	rm -rf $(GENERICTOPDIR)/redfront/$(BUILDDIR)
	rm -f $(REDFRONTSRCDIR)/Makefile $(REDFRONTSRCDIR)/config.h   

#override_dh_auto_configure:
configure: configure-stamp
configure-stamp:
	dh_testdir
	cd $(TOPDIR) ; ./configure --prefix=/usr --with-csl
ifneq ($(BUILDPSL),)
	cd $(TOPDIR) ; ./configure --with-psl
endif
	mkdir -p $(REDFRONTBUILDDIR)
	cd $(REDFRONTSRCDIR) ; autoconf ; autoheader
	cd $(REDFRONTBUILDDIR) ; ../../src/configure --with-libedit --with-redfront-root=/usr/share/reduce-addons/redfront --with-package-map=/usr/share/reduce/packages/package.map --with-csl-reduce=/usr/share/reduce/cslbuild/csl/reduce --with-bpsl=/usr/share/reduce/pslbuild/psl/bpsl --with-reduce-img=/usr/share/reduce/pslbuild/red/reduce.img
	touch configure-stamp


build:	configure-stamp build-stamp
build-stamp:
	dh_testdir
#	cd $(TOPDIR) ; make
	cd $(CSLBUILDDIR) ; make
ifneq ($(BUILDPSL),)
	cd $(PSLBUILDDIR) ; make
endif
	cd $(DOCMISCDIR) ; make
	cd $(DOCSRCDIR) ; make
	cd $(REDFRONTBUILDDIR) ; make
	touch build-stamp


install: install-stamp
install-stamp: build-stamp
# create target directories
	mkdir -p $(SHAREDIR)/scripts $(LIBDIR)/pslbuild/psl $(LIBDIR)/pslbuild/red $(LIBDIR)/cslbuild/csl $(SHAREDIR)/packages $(BINDIR) $(DOCDIR) $(MANDIR)/man1
	mkdir -p $(REDFRONTSHAREDIR)/redfront $(EMACSSITELISPDIR) $(EMACSSITESTARTDIR) $(ADDONDOCDIR)
# copy documentation files
	cp $(TOPDIR)/doc/misc/primer.tex $(TOPDIR)/doc/misc/primer.pdf $(TOPDIR)/doc/misc/sl.tex $(TOPDIR)/doc/misc/sl.bib $(TOPDIR)/doc/misc/sl.pdf \
           $(TOPDIR)/csl/reduce.doc/BINARY-LICENSE.txt $(TOPDIR)/csl/reduce.doc/BSD-LICENSE.txt $(TOPDIR)/csl/reduce.doc/LGPL-2.1.txt $(TOPDIR)/doc/manual/redlogo.png $(DOCDIR)
	cp $(DOCSRCDIR)/*.tex $(DOCDIR)
	cp $(DOCSRCDIR)/$(DOCBASENAME).pdf $(DOCSRCDIR)/$(DOCBASENAME)*.html $(DOCSRCDIR)/$(DOCBASENAME)*.png $(DOCSRCDIR)/$(DOCBASENAME).css $(DOCDIR)
	for n in $(EXTRADOCIMAGEBASENAMES); do cp $(DOCSRCDIR)/${n}*.png $(DOCDIR) ; done
	cp $(DOCDIR)/$(DOCBASENAME).html $(DOCDIR)/index.html
	chmod -x $(DOCDIR)/*
	cp $(REDFRONTSRCDIR)/README $(ADDONDOCDIR)/README
	cp $(GENERICTOPDIR)/breduce/breduce.tex $(GENERICTOPDIR)/breduce/breduce.bbl $(GENERICTOPDIR)/breduce/breduce.pdf $(ADDONDOCDIR)
# copy man files
	cp debian/redcsl.1 debian/redpsl.1 $(MANDIR)/man1
	cp $(REDFRONTSRCDIR)/redfront.1 $(MANDIR)/man1
	ln -s redfront.1 $(MANDIR)/man1/rfcsl.1
	ln -s redfront.1 $(MANDIR)/man1/rfpsl.1
	cp $(GENERICTOPDIR)/breduce/breduce.1 $(MANDIR)/man1
# copy CSL files
	cp -r $(CSLBUILDDIR)/csl/reduce.img $(CSLBUILDDIR)/csl/reduce $(CSLBUILDDIR)/csl/reduce.resources $(LIBDIR)/cslbuild/csl
#	$(RSYNC_CMD) --no-perms $(CSLBUILDDIR)/csl/reduce.doc/ $(DOCDIR)/
	mkdir -p $(FONTDIR)
	$(RSYNC_CMD) --chmod=Fa-x --exclude "/src/***" $(CSLBUILDDIR)/csl/reduce.fonts/ $(FONTDIR)
#	chmod -x $(FONTDIR)/*.ttf $(FONTDIR)/*.pfa $(FONTDIR)/*.pfb
ifneq ($(BUILDPSL),)                                                          # copy PSL files
	$(RSYNC_CMD) --exclude "kernel/***" --exclude "xport.*" $(PSLBUILDDIR)/psl/ $(LIBDIR)/pslbuild/psl/
	chmod -x $(LIBDIR)/pslbuild/psl/*.b
	$(RSYNC_CMD) $(PSLBUILDDIR)/red/ $(LIBDIR)/pslbuild/red/
	chmod -x $(LIBDIR)/pslbuild/red/*
	$(TOPDIR)/psl/saveimage.sh $(PSLBUILDDIR) $(abspath $(LIBDIR)/pslbuild/red) /usr/lib/reduce/pslbuild
endif
# copy common files
	$(RSYNC_CMD) --no-perms --chmod=Fa-x --exclude "/regressions/***" $(TOPDIR)/packages/ $(SHAREDIR)/packages/
	chmod a+x $(TOPDIR)/packages/gcref/gcref $(TOPDIR)/packages/redlog/regressions/make.sh
	ln -f -s ../../../../share/reduce/fonts $(LIBDIR)/cslbuild/csl/reduce.fonts
	ln -f -s ../../../../share/doc/reduce $(LIBDIR)/cslbuild/csl/reduce.doc
	ln -f -s ../../lib/reduce/pslbuild $(SHAREDIR)/pslbuild
	ln -f -s ../../lib/reduce/cslbuild $(SHAREDIR)/cslbuild
# copy font files for CSL
	mkdir -p $(TTFONTDIR) $(TYPE1FONTDIR)
	cp $(CSLBUILDDIR)/csl/reduce.fonts/*.ttf $(TTFONTDIR)
	cp $(CSLBUILDDIR)/csl/reduce.fonts/*.pfb $(TYPE1FONTDIR)
	chmod -x $(TTFONTDIR)/* $(TYPE1FONTDIR)/*
# copy shell scripts for running REDUCE
	cp -a debian/runpsl.sh $(BINDIR)/redpsl
	cp -a debian/runcsl.sh $(BINDIR)/redcsl
# copy rest
	cp $(REDFRONTBUILDDIR)/redfront $(BINDIR)
	ln -s redfront $(BINDIR)/rfcsl
	ln -s redfront $(BINDIR)/rfpsl
	cp $(GENERICTOPDIR)/breduce/breduce $(BINDIR)
	cp $(GENERICTOPDIR)/emacs/reduce-mode.el $(EMACSSITELISPDIR)
	cp debian/50reduce-emacs.el $(EMACSSITESTARTDIR)
	chmod a-x $(EMACSSITELISPDIR)/reduce-mode.el $(EMACSSITESTARTDIR)/50reduce-emacs.el

# run dh_install to copy the files into the package build dirs
	dh_install

	touch install-stamp


# Build architecture-independent files here.
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installmenu -i
	dh_installemacsen -i
	dh_installcron -i
	dh_installman -i
#	dh_desktop -i
	dh_installinfo -i
	dh_installchangelogs  -i
	dh_lintian -i
	dh_link -i
	dh_strip -i
	dh_compress -i 
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installemacsen -a
	dh_installcron -a
	dh_installman -a
#	dh_desktop -a
	dh_installinfo -a
	dh_installchangelogs  -a
	dh_lintian -a
	dh_link -a
	dh_strip -a $(NO_STRIP)
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
